#ifndef TEST_DLL_SERIALIZE_HPP
#define TEST_DLL_SERIALIZE_HPP

#include <boost/serialization/assume_abstract.hpp>
#include <boost/serialization/export.hpp>

#include <test-dll/autolink.hpp>
#include <test-dll/objects.hpp>

///////////////////////////////////////////////////////////////////////////////

namespace boost::serialization {
  template<class Archive>
  CPE_API void
  serialize(Archive& ar, cpe::object_t& o, const unsigned int /*version*/);

  template<class Archive>
  CPE_API void
  serialize(Archive& ar, cpe::derived_t& c, const unsigned int /*version*/);
}

///////////////////////////////////////////////////////////////////////////////

BOOST_SERIALIZATION_ASSUME_ABSTRACT(cpe::object_t)

BOOST_CLASS_EXPORT_KEY(cpe::object_t)
BOOST_CLASS_EXPORT_KEY(cpe::derived_t)

#endif
